package
{
	import com.adobe.portfolio.properties.CommonProperties;
	import com.adobe.portfolio.properties.PropertyBinaryValue;
	import com.adobe.portfolio.properties.PropertyBooleanValue;
	import com.adobe.portfolio.properties.PropertyContext;
	import com.adobe.portfolio.properties.PropertyListValue;
	
	[Bindable]
	public class CustomProperties extends CommonProperties
	{
		public var layout:PropertyListValue;
		public var miniNavVisibility:PropertyListValue;
		public var showNextPrev:PropertyBooleanValue;
		public var showHScrollBar:PropertyBooleanValue;
		public var showVScrollBar:PropertyBooleanValue;
		public var showCardSlider:PropertyBooleanValue;
		public var virtualLayout:PropertyBooleanValue;
		
		public function CustomProperties()
		{
			super();
		}
		
		protected function initListField(context:PropertyContext, 
										   propertyName:String):void
		{
			var contextProperty:PropertyListValue = context.getProperty(propertyName) as PropertyListValue;
			if (contextProperty == null) {
				contextProperty = new PropertyListValue();
				contextProperty.name = propertyName;
				context.properties.push(contextProperty);
			}
			this[propertyName] = contextProperty;
		}
		
		protected function initBooleanField(context:PropertyContext, 
										 propertyName:String):void
		{
			var contextProperty:PropertyBooleanValue = context.getProperty(propertyName) as PropertyBooleanValue;
			if (contextProperty == null) {
				contextProperty = new PropertyBooleanValue();
				contextProperty.name = propertyName;
				context.properties.push(contextProperty);
			}
			this[propertyName] = contextProperty;
		}
		
		override protected function loadContext(context:PropertyContext):void
		{
			super.loadContext(context);
			if (context == null || context.name != "com.adobe.portfolio.AnyLayout") {
				return;
			}
			
			initListField(context, "layout");
			initListField(context, "miniNavVisibility");
			initBooleanField(context, "showNextPrev");
			initBooleanField(context, "showHScrollBar");
			initBooleanField(context, "showVScrollBar");
			initBooleanField(context, "showCardSlider");
			initBooleanField(context, "virtualLayout");
		}
		
	}
}