package components
{
	import com.adobe.portfolio.cards.ICardProvider;
	import com.adobe.portfolio.cards.ISimpleCard;
	import com.adobe.portfolio.cards.SimpleCard;
	
	import flash.events.Event;
	import flash.events.EventDispatcher;
	
	import mx.binding.utils.BindingUtils;
	import mx.collections.IList;
	
	public class BorgesCardProvider extends EventDispatcher implements ICardProvider
	{
		protected var card:SimpleCard;
		
		private var _list:IList;
		private var _maxCardPosition:int;


		private var _cardPosition:Number;
		
		public function BorgesCardProvider()
		{
			card = new SimpleCard();
			BindingUtils.bindSetter(onListLengthChanged, this, ["list", "length"]);
		}
		
		protected function onListLengthChanged(value:int):void {
			maxCardPosition = value - 1;
		}
		
		[Bindable (name="maxCardPositionChanged")]
		public function get maxCardPosition():Number
		{
			return _maxCardPosition;
		}
		
		public function set maxCardPosition(value:Number):void
		{
			if (_maxCardPosition == value)
				return;
			
			_maxCardPosition = value;
			dispatchEvent(new Event("maxCardPositionChanged"));
		}

		[Bindable (name="cardPositionChanged")]
		public function get cardPosition():Number
		{
			return _cardPosition;
		}
		
		public function set pendingCardPosition(value:Number):void
		{
			if (_cardPosition == value)
				return;
			
			_cardPosition = value;
			dispatchEvent(new Event("cardPositionChanged"));
		}
		
		public function getCard(cardPosition:Number):ISimpleCard
		{
			if (isNaN(cardPosition))
				cardPosition = 0;
			
			card.data = list[cardPosition];
			return card;
		}

		[Bindable]
		public function get list():IList
		{
			return _list;
		}

		public function set list(value:IList):void
		{
			_list = value;
		}

	}
}