package components
{
	import com.adobe.portfolio.components.supportClasses.AutoListen;
	
	import flash.events.Event;
	import flash.events.IEventDispatcher;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	
	import mx.managers.PopUpManager;
	
	import properties.CustomProperties;
	
	import spark.components.Button;
	import spark.components.Group;
	import spark.components.Panel;
	
	public class ControlPanel extends Panel
	{
		[SkinPart(required="false")]
		public var topGroup:Group;
		
		[SkinPart(required="false")]
		public var setHomePanel:Button;

		[SkinPart(required="false")]
		public var doneButton:Button;

		protected var autoListen:AutoListen;
		protected var mouseDown:Point;
		protected var orig:Point;
		
		private var _customProperties:CustomProperties;
		private var _focusIndex:int;

		public function ControlPanel()
		{
			super();
			autoListen = new AutoListen();
		}

		override protected function partAdded(partName:String, instance:Object):void
		{
			super.partAdded(partName, instance);
			switch (instance) {
				case topGroup:
					autoListen.addListener(topGroup, MouseEvent.MOUSE_DOWN, onTitleBarMouseDown);
					break;
				case doneButton:
					autoListen.addListener(doneButton, MouseEvent.CLICK, onClickDoneButton);
					break;
				case setHomePanel:
					autoListen.addListener(setHomePanel, MouseEvent.CLICK, onClickSetHomePanel);
					break;
			}
		}
		
		override protected function partRemoved(partName:String, instance:Object):void
		{
			super.partRemoved(partName, instance);
			autoListen.removeListener(instance as IEventDispatcher);
		}
		
		protected function onTitleBarMouseDown(e:MouseEvent):void
		{
			mouseDown = new Point(e.stageX, e.stageY);
			orig = new Point(x,y);
			autoListen.addListener(stage, MouseEvent.MOUSE_MOVE, onMouseMoved);
			autoListen.addListener(stage, MouseEvent.MOUSE_UP, onMouseUp);
			e.stopImmediatePropagation();
		}
		
		protected function onMouseMoved(e:MouseEvent):void
		{
			var xDelta:Number = e.stageX - mouseDown.x;
			var yDelta:Number = e.stageY - mouseDown.y;
			x = orig.x + xDelta;
			y = orig.y + yDelta;
		}
		
		protected function onMouseUp(e:MouseEvent):void
		{
			autoListen.removeListener(stage, MouseEvent.MOUSE_MOVE);
			autoListen.removeListener(stage, MouseEvent.MOUSE_UP);
		}
		
		protected function onClickDoneButton(e:MouseEvent):void
		{
			dispatchEvent(new Event(Event.CLOSE));
		}
		
		protected function onClickSetHomePanel(e:MouseEvent):void
		{
			if (!customProperties || !customProperties.focusIndex)
				return;
			
			customProperties.focusIndex.numValue = focusIndex;
		}
		

		[Bindable]
		public function get customProperties():CustomProperties
		{
			return _customProperties;
		}

		public function set customProperties(value:CustomProperties):void
		{
			_customProperties = value;
		}

		[Bindable]
		public function get focusIndex():int
		{
			return _focusIndex;
		}

		public function set focusIndex(value:int):void
		{
			_focusIndex = value;
		}
		
	}
}