package layouts
{
	import com.adobe.portfolio.layouts.BasicTileLayout;
	
	import mx.core.IVisualElement;
	
	public class BorgesPanelLayout extends BasicTileLayout
	{
		private var _centerRowContent:Boolean;
		
		public function BorgesPanelLayout()
		{
			super();
		}
		
		override protected function justifyCards():void
		{
			super.justifyCards();
			
			if (!centerRowContent)
				return;
			
			var numElements : int = target.numElements;
			for (var i:int = 0; i < numElements; i++ ) {
				var element:IVisualElement = target.getElementAt(i);
				if (element == null) {
					continue;
				}
				
				var yOffset:Number =  (rowHeight - element.height) / 2;
				element.setLayoutBoundsPosition(element.x, element.y + yOffset);
			}
		}


		[Bindable]
		public function get centerRowContent():Boolean
		{
			return _centerRowContent;
		}

		public function set centerRowContent(value:Boolean):void
		{
			_centerRowContent = value;
		}

	}
}