package utils
{
	public class Util3D
	{
		public function Util3D()
		{
		}
		
		protected function addGrid():void
		{
			var container:IVisualElementContainer = layout.target.parent as IVisualElementContainer;
			if (!container)
				return;
			
			var colors:Array = [0xffcccc, 0xccffcc, 0xccccff];
			
			var size:Point = new Point(400,400);
			var angle:Number = -45;
			var origin:Point = new Point(-size.x,0);
			origin = origin.subtract(new Point(size.x/2, size.y/2));
			for (var i:int = 0; i < 3; i++) {
				addElement(container, makeRect(origin.x, origin.y, 50, size, angle, colors[i]));
				//				angle += 45;
				origin.x += size.x;
			}
		}
		
		protected function applyMatrixToElements(matrix:Matrix3D):void
		{
			for each (var obj:Object in elementDict) {
				var element:IVisualElement = obj.element;
				var m:Matrix3D = new Matrix3D(elementDict[element].matrix.rawData);
				m.prepend(matrix);
				element.setLayoutMatrix3D(m, true);
				var delta:Vector3D = m.transformVector(new Vector3D());
				element.depth = -delta.z;
			}
		}
		
		protected var elementDict:Dictionary;
		
		protected function addElement(container:IVisualElementContainer, element:IVisualElement):void
		{
			if (!elementDict)
				elementDict = new Dictionary();
			
			container.addElement(element);
			elementDict[element] = {element:element, matrix:element.getLayoutMatrix3D()};
		}
		
		protected function rotate(angle:Number, size:Point, m:Matrix3D):void
		{
			if (angle == 0)
				return;
			
			m.prependTranslation(size.x/2,size.y/2,0);
			m.prependRotation(angle, Vector3D.Y_AXIS);
			m.prependTranslation(-size.x/2,-size.y/2,0);
		}
		
		protected function makeRect(x:Number, y:Number, z:Number = 0, size:Point=null, angle:Number = 0, color:uint = 0x000000):Rect
		{
			var r:Rect = new Rect();
			r.width = size.x;
			r.height = size.y;
			r.fill = new SolidColor(color);
			var m:Matrix3D = new Matrix3D();
			//			rotate(angle, size, m);
			m.appendTranslation(x, y, z);
			r.setLayoutMatrix3D(m, true);
			r.depth = -z;
			return r;
		}

	}
}