package
{
	import com.adobe.portfolio.properties.CommonProperties;
	import com.adobe.portfolio.properties.PropertyContext;
	import com.adobe.portfolio.properties.PropertyNumberValue;
	import com.adobe.portfolio.properties.PropertyValue;
	
	public class CustomProperties extends CommonProperties
	{
		public function CustomProperties()
		{
			super();
		}
		
		[Bindable]
		public var horizontalDistance:PropertyNumberValue;
		[Bindable]
		public var selectedItemProximity:PropertyNumberValue;
		[Bindable]
		public var depthDistance:PropertyNumberValue;
		[Bindable]
		public var elementRotation:PropertyNumberValue;
		[Bindable]
		public var focalLength:PropertyNumberValue;
		[Bindable]
		public var projectionX:PropertyNumberValue;
		[Bindable]
		public var projectionY:PropertyNumberValue;
		
		[Bindable]
		public var axisAngle:PropertyNumberValue;
		
		override protected function loadContext(context:PropertyContext):void
		{
			super.loadContext(context);
			if (context == null) {
				return;
			}
			
			var defaultProperty:PropertyNumberValue;
			switch (context.name) {
				case "com.joel.wheel":
					axisAngle = context.getProperty("axisAngle") as PropertyNumberValue;
					if (axisAngle == null) {
						defaultProperty = new PropertyNumberValue();
						defaultProperty.value = 0;
						axisAngle = defaultProperty;
					}
					break;
				case "com.rialvalue.coverflow":
					horizontalDistance = context.getProperty("horizontalDistance") as PropertyNumberValue;
					selectedItemProximity = context.getProperty("selectedItemProximity") as PropertyNumberValue;
					if (selectedItemProximity == null) {
						defaultProperty = new PropertyNumberValue();
						defaultProperty.value = 75;
						selectedItemProximity = defaultProperty;
					}
					depthDistance = context.getProperty("depthDistance") as PropertyNumberValue;
					if (depthDistance == null) {
						defaultProperty = new PropertyNumberValue();
						defaultProperty.value = 1;
						depthDistance = defaultProperty;
					}
					elementRotation = context.getProperty("elementRotation") as PropertyNumberValue;
					if (elementRotation == null) {
						defaultProperty = new PropertyNumberValue();
						defaultProperty.value = -70;
						elementRotation = defaultProperty;
					}
					focalLength = context.getProperty("focalLength") as PropertyNumberValue;
					if (focalLength == null) {
						defaultProperty = new PropertyNumberValue();
						defaultProperty.value = 300;
						focalLength = defaultProperty;
					}
					projectionX = context.getProperty("projectionX") as PropertyNumberValue;
					if (projectionX == null) {
						defaultProperty = new PropertyNumberValue();
						defaultProperty.value = -1;
						projectionX = defaultProperty;
					}
					projectionY = context.getProperty("projectionY") as PropertyNumberValue;
					if (projectionY == null) {
						defaultProperty = new PropertyNumberValue();
						defaultProperty.value = -1;
						projectionY = defaultProperty;
					}
					break;
			}
		}
	}
}