package
{
	import com.adobe.portfolio.properties.CommonProperties;
	import com.adobe.portfolio.properties.PropertyContext;
	import com.adobe.portfolio.properties.PropertyNumberValue;
	import com.adobe.portfolio.properties.PropertyValue;
	
	import flash.globalization.NumberParseResult;
	
	[Bindable]
	public class CustomProperties extends CommonProperties
	{
		public function CustomProperties()
		{
			super();
		}
		
		public var fieldOfView:PropertyNumberValue;
		public var itemDistance:PropertyNumberValue;
		public var yAngle:PropertyNumberValue;
		public var zDistance:PropertyNumberValue;
		public var zDistancePower:PropertyNumberValue;
		public var zAngle:PropertyNumberValue;
		public var sineAmp:PropertyNumberValue;
		public var sinePhase:PropertyNumberValue;
		
		protected function initNumberField(context:PropertyContext, 
										   propertyName:String, 
										   value:Number, minValue:Number = NaN, maxValue:Number = NaN):void
		{
			var contextProperty:PropertyNumberValue = context.getProperty(propertyName) as PropertyNumberValue;
			if (contextProperty == null) {
				contextProperty = new PropertyNumberValue();
				contextProperty.minValue = minValue;
				contextProperty.maxValue = maxValue;
				contextProperty.numValue = value;
			}
			this[propertyName] = contextProperty;
		}
		
		override protected function loadContext(context:PropertyContext):void
		{
			super.loadContext(context);
			if ((context == null) || (context.name != "com.adobe.portfolio.NewWave")) {
				return;
			}
			
			initNumberField(context, "fieldOfView", 15, 1, 179);
			initNumberField(context, "itemDistance", 30, 0, 200);
			initNumberField(context, "zDistance", 400, 0, 2500);
			initNumberField(context, "zDistancePower", 10, 1, 20);
			initNumberField(context, "yAngle", 45, 0, 120);
			initNumberField(context, "zAngle", 8, 0, 360);
			initNumberField(context, "sineAmp", 8, 0, 50);
			initNumberField(context, "sinePhase", 70, 0, 180);
		}
	}
}