/*************************************************************************
*
* ADOBE SYSTEMS INCORPORATED
*  Copyright 2010 Adobe Systems Incorporated
*  All Rights Reserved.
*
* NOTICE:  Adobe permits you to use, modify, and distribute this 
* file in accordance with the terms of the Adobe license agreement 
* accompanying it.  If you have received this file from a source 
* other than Adobe, then your use, modification, or distribution 
* of it requires the prior written permission of Adobe.
**************************************************************************/

package com.adobe.portfolio.cards
{
	

	[SkinState("smallNormal")]
	[SkinState("mediumNormal")]
	[SkinState("largeNormal")]
	[SkinState("infoNormal")]
	
	[SkinState("smallOver")]
	[SkinState("mediumOver")]
	[SkinState("largeOver")]
	[SkinState("infoOver")]
	
	[SkinState("smallSelected")]
	[SkinState("mediumSelected")]
	[SkinState("largeSelected")]
	[SkinState("infoSelected")]
	
	[SkinState("smallOverAndSelected")]
	[SkinState("mediumOverAndSelected")]
	[SkinState("largeOverAndSelected")]
	[SkinState("infoOverAndSelected")]
	
	/** TODO This interface currently contains all the properties that can be queried by skins,
	 *  but does not specify skin parts (it results in a build error right now)
	 */
	
	/**
	 *  IBasicCard is an interface that extends ISimpleCard and describes the minimum capabilities of a BasicCard.  
	 * 
	 *  @langversion 3.0
	 *  @playerversion Flash 10.1
	 *  @playerversion AIR 2.0
	 *  @productversion Portfolio 10.0
	 *
	 */	
	public interface IBasicCard extends ISimpleCard
	{
		/**
		 *  Get the current state of the card
		 * 
		 *  @return The current state of the card
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */	
		function get currentState():String;
		
		/**
		 *  Set the current state of the card
		 * 
		 *  @param stateName The name of the new current state
		 *  @param playTransition If <code>true</code> then play the state transition effect.
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */	
		function setCurrentState(stateName:String, playTransition:Boolean = true):void;
	}
}