/*************************************************************************
*
* ADOBE SYSTEMS INCORPORATED
*  Copyright 2010 Adobe Systems Incorporated
*  All Rights Reserved.
*
* NOTICE:  Adobe permits you to use, modify, and distribute this 
* file in accordance with the terms of the Adobe license agreement 
* accompanying it.  If you have received this file from a source 
* other than Adobe, then your use, modification, or distribution 
* of it requires the prior written permission of Adobe.
**************************************************************************/

package com.adobe.portfolio.cards
{
	[SkinState("previewNormal")]
	[SkinState("previewInfo")]
	
	/**
	 *  IPreviewCard is an interface that extends ISimpleCard and describes the minimum capabilities of a PreviewCard.  
	 * 
	 *  @langversion 3.0
	 *  @playerversion Flash 10.1
	 *  @playerversion AIR 2.0
	 *  @productversion Portfolio 10.0
	 *
	 */	
	public interface IPreviewCard extends ISimpleCard
	{
		/**
		 *  Get the current state of the previewCard
		 * 
		 *  @return The current state of the previewCard
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */	
		function get currentState():String;
		
		/**
		 *  Set the current state of the previewCard
		 * 
		 *  @param stateName The name of the new current state
		 *  @param playTransition If <code>true</code> then play the state transition effect.
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */	
		function setCurrentState(stateName:String, playTransition:Boolean = true):void;
		
		/**
		 *  Whether page navigation is enabled (via keyboard, mousewheel)
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.1
		 */	
		function set pageNavigationEnabled(value:Boolean):void;
	}
}