package com.adobe.portfolio.components
{
	import com.adobe.portfolio.managers.StringManager;
	
	import flash.events.MouseEvent;
	import flash.net.URLRequest;
	import flash.net.navigateToURL;
	
	import spark.components.Button;

	/**
	 * The BestExperienceAlert class extends NavAlert and displays an alert about obtaining the best experience for that navigator.
	 * 
  	 *  @langversion 3.0
	 *  @playerversion Flash 10.1
	 *  @playerversion AIR 2.0
	 *  @productversion Portfolio 10.0
	 */
	public class BestExperienceAlert extends NavAlert
	{
		[SkinPart(required="true")]
		public var getReaderNow:Button;

		/**
		 *  Constructor.
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 */
		public function BestExperienceAlert()
		{
			super();
			percentWidth = 95;
			percentHeight = 95;
		}
		
		override protected function partAdded(partName:String, instance:Object):void
		{
			super.partAdded(partName, instance);
			switch (instance) {
				case getReaderNow:
					addListener(getReaderNow, MouseEvent.CLICK, onGetReaderNow);
					break;
				default:
					break;
			}
		}
		
		protected function onGetReaderNow(event:MouseEvent):void {
			navigateToURL(new URLRequest(StringManager.instance.getReaderURL));
		}

	}
}