/*************************************************************************
*
* ADOBE SYSTEMS INCORPORATED
*  Copyright 2010 Adobe Systems Incorporated
*  All Rights Reserved.
*
* NOTICE:  Adobe permits you to use, modify, and distribute this 
* file in accordance with the terms of the Adobe license agreement 
* accompanying it.  If you have received this file from a source 
* other than Adobe, then your use, modification, or distribution 
* of it requires the prior written permission of Adobe.
**************************************************************************/

package com.adobe.portfolio.components
{
	import mx.accessibility.AccConst;
	import mx.accessibility.AccImpl;
	import mx.core.UIComponent;
	
	/**
	 * The FileCountAccImpl class extends AccImpl (AccessibilityImplementation) and allows one to set the role to static text.  Used by FileCount.
	 */
	public class FileCountAccImpl extends AccImpl
	{
		public function FileCountAccImpl(master:UIComponent)
		{
			super(master);
		}
		
		override public function get_accRole(childID:uint):uint
		{
			return AccConst.ROLE_SYSTEM_STATICTEXT;
		}
		
		override public function get_accState(childID:uint):uint
		{
			return AccConst.STATE_SYSTEM_UNAVAILABLE;
		}
		
		override public function get_accValue(childID:uint):String
		{
			var fileCount:Filecount = master as Filecount;
			var retVal:String = (fileCount.fileIndex  + 1).toString() + ' / ' + fileCount.fileCount.toString(); // needs to match string of skin
			return retVal;
		}
	}
}