package com.adobe.portfolio.components
{
	import flash.display.DisplayObject;
	import flash.text.TextFormat;
	
	import mx.controls.DateChooser;
	import mx.core.IUITextField;
	import mx.core.UIFTETextField;
	import mx.core.mx_internal;
	
	use namespace mx_internal;
	
	/**
	 *  Standard mx controls do not work well with the portfolio framework because of extensions related to fonts.
	 *  This subclass of DateChooser overcomes that limitation.
	 * 
  	 *  @langversion 3.0
	 *  @playerversion Flash 10.1
	 *  @playerversion AIR 2.0
	 *  @productversion Portfolio 10.0
	 */
	public class NavDateChooser extends DateChooser
	{
		/**
		 *  Constructor.
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 */
		public function NavDateChooser()
		{
			super();
		}
		
		// Override DateChoose's internal createMonthDisplay method so we can have it use FTE
		override mx_internal function createMonthDisplay(childIndex:int):void
		{
			if (!monthDisplay)
			{
				monthDisplay = IUITextField(createInFontContext(UIFTETextField));
				
				var textFormat:TextFormat = determineTextFormatFromStyles();
				monthDisplay.defaultTextFormat = textFormat;
				monthDisplay.visible = false;
				monthDisplay.selectable = false;
				
				if (childIndex == -1)
					addChild(DisplayObject(monthDisplay));          
				else
					addChildAt(DisplayObject(monthDisplay), childIndex);
				
				var dateHeaderStyleName:Object = getStyle("headerStyleName");
				if (!dateHeaderStyleName)
					dateHeaderStyleName = this;
				monthDisplay.styleName = dateHeaderStyleName;
				setMonthWidth();
			}
			
		}

		// Override DateChoose's internal createYearDisplay method so we can have it use FTE
		override mx_internal function createYearDisplay(childIndex:int):void
		{
			if (!yearDisplay)
			{
				yearDisplay = IUITextField(createInFontContext(UIFTETextField));
				
				var textFormat:TextFormat = determineTextFormatFromStyles();
				yearDisplay.defaultTextFormat = textFormat;
				yearDisplay.visible = false;
				yearDisplay.selectable = false;
				
				if (childIndex == -1)
					addChild(DisplayObject(yearDisplay));
				else
					addChildAt(DisplayObject(yearDisplay), childIndex);
				
				var dateHeaderStyleName:Object = getStyle("headerStyleName");
				if (!dateHeaderStyleName)
					dateHeaderStyleName = this;
				yearDisplay.styleName = dateHeaderStyleName;
			}
		}
	}
}