package com.adobe.portfolio.components
{
	import mx.events.ValidationResultEvent;
	
	import spark.components.TextInput;
	
	/**
	 *  The NavTextInput class extends TextInput to provide extra navigator specific functionality.
	 * 
  	 *  @langversion 3.0
	 *  @playerversion Flash 10.1
	 *  @playerversion AIR 2.0
	 *  @productversion Portfolio 10.0
	 */
	public class NavTextInput extends TextInput
	{
		/**
		 *  Constructor.
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 */
		public function NavTextInput()
		{
			super();
		}
		
		/**
		 *  Override the super to prevent a system tooltip with an error message from being displayed when user enters invalid input.
		 *
		 *  @param event The event object for the validation.
		 *
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 */
		override public function validationResultHandler(event:ValidationResultEvent):void
		{
			// overrride the super and do nothing.
			// this prevents a system tooltip with an error message from being displayed
		}
	}
}