/*************************************************************************
*
* ADOBE SYSTEMS INCORPORATED
*  Copyright 2010 Adobe Systems Incorporated
*  All Rights Reserved.
*
* NOTICE:  Adobe permits you to use, modify, and distribute this 
* file in accordance with the terms of the Adobe license agreement 
* accompanying it.  If you have received this file from a source 
* other than Adobe, then your use, modification, or distribution 
* of it requires the prior written permission of Adobe.
**************************************************************************/

package com.adobe.portfolio.components.details
{
	import flash.display.Sprite;
	
	import mx.core.BitmapAsset;
	
	/**
	 *  The DetailsResizeCursor class extends Sprite to implement a resize cursor in the Details navigator. 
	 * 
	 *  @langversion 3.0
	 *  @playerversion Flash 10.1
	 *  @playerversion AIR 2.0
	 *  @productversion Portfolio 10.0
	 *
	 */	
	public class DetailsResizeCursor extends Sprite
	{
		/**
		 * @private
		 */
		[Embed(source="../../../../../assets/resizeCursor.png")]
		public static var cursorCls:Class;
		/**
		 * @private
		 */
		public static var bitmap:BitmapAsset = BitmapAsset(new cursorCls());
		
		/**
		 *  Constructor. 
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */	
		public function DetailsResizeCursor()
		{
			graphics.beginBitmapFill(bitmap.bitmapData);
			graphics.drawRect(0, 0, bitmap.width, bitmap.height);
			graphics.endFill();
		}
	}
}