/*************************************************************************
*
* ADOBE SYSTEMS INCORPORATED
*  Copyright 2010 Adobe Systems Incorporated
*  All Rights Reserved.
*
* NOTICE:  Adobe permits you to use, modify, and distribute this 
* file in accordance with the terms of the Adobe license agreement 
* accompanying it.  If you have received this file from a source 
* other than Adobe, then your use, modification, or distribution 
* of it requires the prior written permission of Adobe.
**************************************************************************/

package com.adobe.portfolio.components.supportClasses
{
	import mx.core.IVisualElement;
	
	import spark.components.ToggleButton;
	
	/**
	 * FlashButton is a skinnable implementation of IFlashComponent that is suitable for using
	 * dynamically-loaded Flash assets as part of a Button skin.
	 */
	public class FlashToggleButton extends ToggleButton implements IFlashComponent
	{
		/**
		 * Default constructor for FlashButton.
		 */
		public function FlashToggleButton()
		{
			super();
		}
		
		[Bindable]
		/**
		 * A visual element to be drawn if the Flash asset specified by swfFile and swfClass cannot be found.
		 */
		public var fallback:IVisualElement;
		
		private var _swfClass:String = "";
		[Bindable]
		/**
		 * @inheritDoc
		 * 
		 * @see com.adobe.portfolio.managers.FlashSkinManager
		 */
		public function get swfClass():String
		{
			return _swfClass;
		}
		public function set swfClass(val:String):void
		{
			_swfClass = val;
		}
	}
}