/*************************************************************************
*
* ADOBE SYSTEMS INCORPORATED
*  Copyright 2010 Adobe Systems Incorporated
*  All Rights Reserved.
*
* NOTICE:  Adobe permits you to use, modify, and distribute this 
* file in accordance with the terms of the Adobe license agreement 
* accompanying it.  If you have received this file from a source 
* other than Adobe, then your use, modification, or distribution 
* of it requires the prior written permission of Adobe.
**************************************************************************/

package com.adobe.portfolio.components.supportClasses
{
	/**
	 * An IFlashComponent is used to reference an object type in an external SWF file.
	 * This allows assets to be accessed dynamically rather than requiring them as a SWC
	 * at compile time.
	 * 
	 * The primary use case is for skin assets created in Flash Professional to be used
	 * in Flex applications, and changed dynamically at runtime.
	 */
	public interface IFlashComponent
	{
		/**
		 * Returns the name of the stage instance for this component within a designer skin swf.
		 * 
		 * @see com.adobe.portfolio.managers.FlashSkinManager
		 */
		function get swfClass():String;
	}
}