package com.adobe.portfolio.events
{
	import flash.events.Event;
	
	/**
	 *  The JobQueueEvent class extends Event and is dispatched by com.adobe.portfolio.utils.JobQueue.
	 * 
	 *  @langversion 3.0
	 *  @playerversion Flash 10.1
	 *  @playerversion AIR 2.0
	 *  @productversion Portfolio 10.0
	 * 
	 *  @see JobQueue
	 *
	 */
	public class JobQueueEvent extends Event
	{
		/**
		 *  Dispatched when a jobQueue becomes empty.
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 */
		public static const QUEUE_IS_EMPTY:String = "queueIsEmpty";

		/**
		 *  Constructor.
		 * 
		 *  @param type Type of event
		 *  @param bubbles Whether event bubbles or not.
		 *  @param cancelable Whether event is cancelable
		 * 
		 *  @see flash.events.Event
		 *  @see #QUEUE_IS_EMPTY
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public function JobQueueEvent(type:String, bubbles:Boolean=false, cancelable:Boolean=false)
		{
			super(type, bubbles, cancelable);
		}
	}
}