/*************************************************************************
*
* ADOBE SYSTEMS INCORPORATED
*  Copyright 2010 Adobe Systems Incorporated
*  All Rights Reserved.
*
* NOTICE:  Adobe permits you to use, modify, and distribute this 
* file in accordance with the terms of the Adobe license agreement 
* accompanying it.  If you have received this file from a source 
* other than Adobe, then your use, modification, or distribution 
* of it requires the prior written permission of Adobe.
**************************************************************************/

package com.adobe.portfolio.events
{
	import flash.events.Event;
	
	
	/**
	 *  The LayoutEvent class extends Event and is dispatched by Navigator layouts. 
	 * 
	 *  @langversion 3.0
	 *  @playerversion Flash 10.1
	 *  @playerversion AIR 2.0
	 *  @productversion Portfolio 10.0
	 *
	 */
	public class LayoutEvent extends Event
	{
		
		/**
		 *  A string representing the event type when an attachment focus has been handled.
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		static public const HANDLED_ATTACHMENT_FOCUS:String = "HANDLED_ATTACHMENT_FOCUS";
		
		
		/**
		 *  Constructor
		 * 
		 *  @param type The type of the event as a string, accessible as <code>LayoutEvent.type</code>.
		 *  @param bubbles Determines whether the Event object participates
		 *  in the bubbling stage of the event flow. The default value is <code>false</code>.
		 *  @param cancelable Determines whether the Event object can be canceled. 
		 *  The default values is <code>false</code>.
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public function LayoutEvent(type:String, bubbles:Boolean=false, cancelable:Boolean=false)
		{
			super(type, bubbles, cancelable);
		}
	}
}
