package com.adobe.portfolio.events
{
	import mx.events.PropertyChangeEvent;
	
	/**
	 *  The ThumbnailManagerEvent class extends PropertyChangeEvent and is dispatched by com.adobe.portfolio.managers.ThumbnailMnager.
	 * 
	 *  @langversion 3.0
	 *  @playerversion Flash 10.1
	 *  @playerversion AIR 2.0
	 *  @productversion Portfolio 10.0
	 *
	 */
	public class ThumbnailManagerEvent extends PropertyChangeEvent
	{
		/**
		 *  Type of ThumbnailManagerEvent that is dispatched when an attachment thumbnail changes aspectRatio.
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public static const ASPECT_RATIO_CHANGED:String = "aspectRatioChanged";

		/**
		 *  Constructor
		 * 
	     *  @param type The event type; indicates the action that triggered the event.
	     *
	     *  @param bubbles Specifies whether the event can bubble
	     *  up the display list hierarchy.
	     *
	     *  @param cancelable Specifies whether the behavior
	     *  associated with the event can be prevented.
	     *
	     *  @param kind Specifies the kind of change.
	     *  The possible values are <code>PropertyChangeEventKind.UPDATE</code>,
	     *  <code>PropertyChangeEventKind.DELETE</code>, and <code>null</code>.
	     *
	     *  @param property A String, QName, or int
	     *  specifying the property that changed.
	     *
	     *  @param oldValue The value of the property before the change.
	     *
	     *  @param newValue The value of the property after the change.
	     *
	     *  @param source The object that the change occured on.
		 * 
		 *  @see mx.events.PropertyChangeEvent
		 *  @see #ASPECT_RATIO_CHANGED
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public function ThumbnailManagerEvent(type:String, bubbles:Boolean=false, cancelable:Boolean=false, kind:String=null, property:Object=null, oldValue:Object=null, newValue:Object=null, source:Object=null)
		{
			super(type, bubbles, cancelable, kind, property, oldValue, newValue, source);
		}
	}
}