/*************************************************************************
*
* ADOBE SYSTEMS INCORPORATED
*  Copyright 2010 Adobe Systems Incorporated
*  All Rights Reserved.
*
* NOTICE:  Adobe permits you to use, modify, and distribute this 
* file in accordance with the terms of the Adobe license agreement 
* accompanying it.  If you have received this file from a source 
* other than Adobe, then your use, modification, or distribution 
* of it requires the prior written permission of Adobe.
**************************************************************************/

package com.adobe.portfolio.managers
{
	import com.adobe.portfolio.api.INavigatorHost;
	import com.adobe.portfolio.events.CollectionManagerEvent;
	
	import flash.utils.Dictionary;
	import flash.utils.describeType;

	[Bindable]
	
	/**
	 *  The StringManager provides support for localization of the UI text for the
	 *  navigator.  The properties of a stringManager are the string keys for the various
	 *  pieces of text that are used by the UI. The actual text displayed by a Navigator will be
	 *  determined by the locale and the string values for that locale set in the strings
	 *  resources file.  See the documentation on the Acrobat Navigagtor file format for
	 *  information on the strings resource file. 
	 * 
	 * 
	 *  @langversion 3.0
	 *  @playerversion Flash 10.1
	 *  @playerversion AIR 2.0
	 *  @productversion Portfolio 10.0
	 *
	 */
	public class StringManager
	{
		
		/**
		 *  The key for the "attachment creation date" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var attachmentCreationDate:String = "ATTACHMENT_CREATION_DATE";
		
		/**
		 *  The key for the "attachment description" string.
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var attachmentDescription:String = "ATTACHMENT_DESCRIPTION";
		
		/**
		 *  The key for the "attachment filename" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var attachmentFileName:String = "ATTACHMENT_FILENAME";
		
		/**
		 *  The string key for the "attachment modification date" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var attachmentModDate:String = "ATTACHMENT_MOD_DATE";
		
		/**
		 *  The string key for the "attachment size" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var attachmentSize:String = "ATTACHMENT_SIZE";
		
		/**
		 *  The string key for the "attachment compressed size" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var attachmentCompressedSize:String = "ATTACHMENT_COMPRESSED_SIZE";
		
		/**
		 *  The string key for the "attachment path" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var attachmentPath:String = "ATTACHMENT_PATH";
		
		/**
		 *  The string key for the "previous card" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var previousCard:String = "PREVIOUS_CARD";
		
		/**
		 *  The string key for the "next card" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var nextCard:String = "NEXT_CARD";
		
		/**
		 *  The string key for the "delete file" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var deleteFile:String = "DELETE_FILE";
		
		/**
		 *  The string key for the "extract file" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var extractFile:String = "EXTRACT_FILE";
		
		/**
		 *  The string key for the "delete folder" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var deleteFolder:String = "DELETE_FOLDER";
		
		/**
		 *  The string key for the "extract folder" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var extractFolder:String = "EXTRACT_FOLDER";
		
		/**
		 *  The string key for the "edit file" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var editFile:String = "EDIT_FILE";
		
		/**
		 *  The string key for the "edit file tooltip" string
		 *
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var editFileTooltip:String = "EDIT_FILE_TOOLTIP";
		
		/**
		 *  The string key for the "print file" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var printFile:String = "PRINT_FILE";
		
		/**
		 *  The string key for the "show information" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var showInfo:String = "SHOW_INFO";
		
		/**
		 *  The string key for the "close info" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var closeInfo:String = "CLOSE_INFO";
		
		/**
		 *  The string key for the "back folder" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var backFolder:String = "BACK_FOLDER";
		
		/**
		 *  The string key for the "close folder" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var closeFolder:String = "CLOSE_FOLDER";
		
		/**
		 *  The string key for the "show MiniNav" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var showMiniNav:String = "SHOW_MININAV";
		
		/**
		 *  The string key for the "close MiniNav" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var closeMiniNav:String = "CLOSE_MININAV";
		
		/**
		 *  The string key for the "close preview" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var closePreview:String = "CLOSE_PREVIEW";
		
		/**
		 *  The string key for the "page up" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var pageUp:String = "PAGE_UP";
		
		/**
		 *  The string key for the "page down" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var pageDown:String = "PAGE_DOWN";
		
		/**
		 *  The string key for the "media play" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var mediaPlay:String = "MEDIA_PLAY";
		
		/**
		 *  The string key for the "media pause" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var mediaPause:String = "MEDIA_PAUSE";
		
		/**
		 *  The string key for the "media adjust volume" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var mediaAdjustVolume:String = "MEDIA_ADJUSTVOLUME";
		
		/**
		 *  The string key for the "error playing media file" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var errorPlayingMediaFile:String = "ERROR_PLAYING_MEDIA_FILE";
		
		/**
		 *  The string key for the "For the best experience, ..." string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var bestExperience:String = "For the best experience, open this PDF portfolio in Acrobat X, Reader X, or later.";
		
		/**
		 *  The string key for the "Get Adobe Reader" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var getReaderNow:String = "Get Adobe Reader";
		
		/**
		 *  The string key for the Adobe Acrobat Reader download URL string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var getReaderURL:String = "http://www.adobe.com/go/reader_download";
		
		/**
		 *  The string key for the "ribbon open" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var ribbonOpen:String = "RIBBON_OPEN";
		
		// Canvas List entries
		
		/**
		 *  The string key for the "canvas default text" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var canvasDefaultText:String = "CANVAS_DEFAULT_TEXT";
		
		/**
		 *  The string key for the "set image" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var setImage:String = "SET_IMAGE";
		
		/**
		 *  The string key for the "add image" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var addImage:String = "ADD_IMAGE";
		
		/**
		 *  The string key for the "add text" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var addText:String = "ADD_TEXT";
		
		/**
		 *  The string key for the "remove" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var remove:String = "REMOVE";
		
		/**
		 *  The string key for the "Don't show Welcome Page again" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var welcomeHide:String = "WELCOME_HIDE";

		/**
		 *  The string key for the "Show Welcome Page" string
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public var welcomeShow:String = "WELCOME_SHOW";
		
		// Delete these
		public var fullPreview:String = "FULL_PREVIEW";

		private static var _instance:StringManager = null;
		private static const token:Object = new Object();
		private static var initialized:Boolean = false;
		private static var isHostString:Dictionary;
		
		
		/**
		 *  The current host for the navigator
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		protected var host:INavigatorHost;
		
		private var _localizedStringFunction:Function;
		
		
		/**
		 *  Constructor
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public function StringManager(token:Object)
		{
			if (token != StringManager.token) {
				throw new Error("don't call this constructor directly");
			}
			initIsHostString();
			CollectionManager.instance.addEventListener(CollectionManagerEvent.COLLECTION_CHANGE, hostChanged, false, 0, true);
		}
		
		private function initIsHostString():void {
			if (isHostString)
				return;
			isHostString = new Dictionary();
			isHostString["attachmentCreationDate"] = true;
			isHostString["attachmentDescription"] = true;
			isHostString["attachmentFileName"] = true;
			isHostString["attachmentModDate"] = true;
			isHostString["attachmentSize"] = true;
			isHostString["attachmentCompressedSize"] = true;
			isHostString["attachmentPath"] = true;
		}
		
		
		/**
		 *  Returns a stringManager instance
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public static function get instance():StringManager
		{
			if (_instance == null) {
				_instance = new StringManager(token);
			}
			return _instance;
		}
		
		private function hostChanged(event:CollectionManagerEvent):void {
			
			if (event.kind != CollectionManagerEvent.HOST_CHANGED_KIND)
				return;
				
			if (!event.newVal)
				return;
			host = event.newVal as INavigatorHost;
			initValues();
		}

		private function initValues():void {
			if (initialized)
				return;
			var varList:XMLList = flash.utils.describeType(this)..accessor;
			for (var i:int; i < varList.length(); ++i){
				var key:String = varList[i].@name;
				if (key == "localizedStringFunction")
					continue;
				this[key] = (_localizedStringFunction != null) ? callLocalizedStringFunction(key) : getLocalizedString(key);
			}
			initialized = true;
		}
		
		private function callLocalizedStringFunction(key:String):String 
		{
			var value:String = _localizedStringFunction(host, key);
			if (!value)
				value = this[key];
			
			return value;
		}
		
		
		/**
		 *  Gets a localized string from the navigator's resources contained in the collection. 
         *  Adobe provides support for including sets of localized strings in a navigator's .nav file.
		 *  See the navigator file format documentation for more details.
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		public function getLocalizedString(key:String):String 
		{
			if (isHostString[key])
				return getLocalizedStringHost(key);
			
			return host.collection.getLocalizedString(key, hasOwnProperty(key) ? this[key] : key);
		}
		
		
		/**
		 *  Returns the value of the localized string for the specified key from the 
		 *  hosts strings file resources, if there is such a value.  Otherwise it returns
		 *  the specified key.
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */
		protected function getLocalizedStringHost(key:String):String 
		{
			var value:String = host.getLocalizedString(key);
			if (!value)
				value = this[key];
			
			return value;
		}

		/**
		 *  Setter for localizedStringFunction.  
		 * 
		 *  @param value The value function should take the following form:
		 *  <pre>    getLocalizedString(host:INavigatorHost, key:String):String</pre><br>
		 *  It should take a key and return a localized string value.  The host parameter will never be null.
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 * 
		 */
		public function set localizedStringFunction(value:Function):void
		{
			_localizedStringFunction = value;
		}

	}
}
