/*************************************************************************
*
* ADOBE SYSTEMS INCORPORATED
*  Copyright 2010 Adobe Systems Incorporated
*  All Rights Reserved.
*
* NOTICE:  Adobe permits you to use, modify, and distribute this 
* file in accordance with the terms of the Adobe license agreement 
* accompanying it.  If you have received this file from a source 
* other than Adobe, then your use, modification, or distribution 
* of it requires the prior written permission of Adobe.
**************************************************************************/

package com.adobe.portfolio.previews
{
	/**
	 * A PreviewEvent that is dispatched when the playHeadTime changes.  
	 * 
	 * @see com.adobe.portfolio.events.PreviewEvent#PLAYHEAD_TIME_CHANGED
	 * 
	 *  @langversion 3.0
	 *  @playerversion Flash 10.1
	 *  @playerversion AIR 2.0
	 *  @productversion Portfolio 10.0
	 */
	[Event(name="playHeadTimeChanged", type="com.adobe.portfolio.events.PreviewEvent")]
	
	/**
	 * 
	 * The IPreviewMediaModel interface extends IPreviewModel and defines the
	 * base functionality of the model used by the Preview component for displaying
	 * media content (audio, video).
	 * 
	 *  @langversion 3.0
	 *  @playerversion Flash 10.1
	 *  @playerversion AIR 2.0
	 *  @productversion Portfolio 10.0
	 *
	 */
	public interface IPreviewMediaModel extends IPreviewModel
	{
		[Bindable (name="playHeadTimeChanged")]
		/**
		 * 
		 * The play head time (position) in msec (-1 if unknown or not applicable)
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 */
		function get playHeadTime():Number;
		function set playHeadTime(value:Number):void;
	}
}