/*************************************************************************
*
* ADOBE SYSTEMS INCORPORATED
*  Copyright 2010 Adobe Systems Incorporated
*  All Rights Reserved.
*
* NOTICE:  Adobe permits you to use, modify, and distribute this 
* file in accordance with the terms of the Adobe license agreement 
* accompanying it.  If you have received this file from a source 
* other than Adobe, then your use, modification, or distribution 
* of it requires the prior written permission of Adobe.
**************************************************************************/

package com.adobe.portfolio.previews
{
	import com.adobe.portfolio.events.PreviewEvent;
	
	import flash.display.Bitmap;
	import flash.events.Event;
	import flash.events.EventDispatcher;
	
	/**
	 * 
	 * The PreviewMediaModel class implements the IPreviewMediaModel interface and is required for the Preview component.
	 * 
	 *  @langversion 3.0
	 *  @playerversion Flash 10.1
	 *  @playerversion AIR 2.0
	 *  @productversion Portfolio 10.0
	 *
	 *  @see com.adobe.portfolio.events.PreviewEvent#PLAYHEAD_TIME_CHANGED
	 * 
	 */
	public class PreviewMediaModel extends PreviewModel implements IPreviewMediaModel
	{
		private var _playHeadTime:Number;
		
		[Bindable (name="playHeadTimeChanged")]
		/**
		 * 
		 * The play head time (position) in msec (-1 if unknown or not applicable)
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 */
		public function get playHeadTime():Number
		{
			return _playHeadTime;
		}

		public function set playHeadTime(value:Number):void
		{
			if (_playHeadTime != value)
				return;
			_playHeadTime = value;
			dispatchEvent(new PreviewEvent(PreviewEvent.PLAYHEAD_TIME_CHANGED));
		}

	}
}