/*************************************************************************
*
* ADOBE SYSTEMS INCORPORATED
*  Copyright 2010 Adobe Systems Incorporated
*  All Rights Reserved.
*
* NOTICE:  Adobe permits you to use, modify, and distribute this 
* file in accordance with the terms of the Adobe license agreement 
* accompanying it.  If you have received this file from a source 
* other than Adobe, then your use, modification, or distribution 
* of it requires the prior written permission of Adobe.
**************************************************************************/

package com.adobe.portfolio.properties
{
	import com.adobe.portfolio.managers.CollectionManager;

	/**
	 *  An empty subclass of CommonProperties that can be used by navigators
	 * 	that do not provide custom properties.
	 * 
	 *  @langversion 3.0
	 *  @playerversion Flash 10.1
	 *  @playerversion AIR 2.0
	 *  @productversion Portfolio 10.0
	 *
	 */	
	public class DefaultProperties extends CommonProperties
	{
		/**
		 *  Constructor
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */	
		public function DefaultProperties()
		{
			super();
			
			// There's no property/skin loading to trigger CollectionManager enabling, so do it manually
			CollectionManager.instance.enabled = true;
		}

		/**
		 *  Returns the property files used by this class as an XML List.
		 *  This class does not rely on any additional resource files, so this returns an empty array
		 *  for property files.
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 *
		 */	
		override protected function createXMLList():Array
		{
			return [];
		}
	}
}