/*************************************************************************
*
* ADOBE SYSTEMS INCORPORATED
*  Copyright 2010 Adobe Systems Incorporated
*  All Rights Reserved.
*
* NOTICE:  Adobe permits you to use, modify, and distribute this 
* file in accordance with the terms of the Adobe license agreement 
* accompanying it.  If you have received this file from a source 
* other than Adobe, then your use, modification, or distribution 
* of it requires the prior written permission of Adobe.
**************************************************************************/

////////////////////////////////////////////////////////////////////////////////

//

//  ADOBE SYSTEMS INCORPORATED

//  Copyright 2005-2006 Adobe Systems Incorporated

//  All Rights Reserved.

//

//  NOTICE: Adobe permits you to use, modify, and distribute this file

//  in accordance with the terms of the license agreement accompanying it.

//

////////////////////////////////////////////////////////////////////////////////



package com.adobe.portfolio.skins

{



import flash.display.Graphics;

import flash.filters.DropShadowFilter;



import mx.skins.RectangularBorder;



/**

 *  The skin for a ToolTip.

 *  

 *  @langversion 3.0

 *  @playerversion Flash 9

 *  @playerversion AIR 1.1

 *  @productversion Flex 3

 */

public class NavToolTipBorder extends RectangularBorder

{

	

	//--------------------------------------------------------------------------

	//

	//  Constructor

	//

	//--------------------------------------------------------------------------



	/**

	 *  Constructor.

	 *  

	 *  @langversion 3.0

	 *  @playerversion Flash 9

	 *  @playerversion AIR 1.1

	 *  @productversion Flex 3

	 */

	public function NavToolTipBorder() 

	{

		super(); 

	}

	

	//--------------------------------------------------------------------------

	//

	//  Variables

	//

	//--------------------------------------------------------------------------

	

	/**

	 *  @private

	 */

	private var textDropShadow:DropShadowFilter;

	

	

	/**

	 *  @private

	 *  Draw the background and border.

	 */

	override protected function updateDisplayList(w:Number, h:Number):void

	{	

		super.updateDisplayList(w, h);

		

		var backgroundColor:uint = 0xF2F2F2;

		var backgroundAlpha:Number= .9;

		var borderColor:uint = 0x878787;

		

		filters = [];

		

		var g:Graphics = graphics;

		g.clear();

		g.moveTo(-9, -13);

		g.beginFill(backgroundColor, backgroundAlpha);

		g.lineStyle(1, borderColor, 1, false, "normal", null, "miter");

		g.drawRect(0, 0, w - 0, h - 2);

		g.endFill();

		

		filters = [ new DropShadowFilter(1, 90, 0, 1, 5, 5, .5, 2) ];

		

	}

}



}

