/*************************************************************************
*
* ADOBE SYSTEMS INCORPORATED
*  Copyright 2010 Adobe Systems Incorporated
*  All Rights Reserved.
*
* NOTICE:  Adobe permits you to use, modify, and distribute this 
* file in accordance with the terms of the Adobe license agreement 
* accompanying it.  If you have received this file from a source 
* other than Adobe, then your use, modification, or distribution 
* of it requires the prior written permission of Adobe.
**************************************************************************/

/*
InternalAdobePatentID="B1283E1"
InternalAdobePatentID="B1283E2"
*/

package com.adobe.portfolio.skins
{
	import com.adobe.portfolio.managers.CollectionManager;
	
	import mx.modules.Module;
	import mx.styles.CSSStyleDeclaration;
	import mx.styles.IStyleManager2;
	import mx.styles.IStyleModule;
	
	public class SkinModule extends Module implements IStyleModule
	{
		public function SkinModule()
		{
			super();
		}
		
		[Bindable]
		public var styleSelectorArray:Array;
		
		protected var backupManager:IStyleManager2 = null;
		protected var backupStyles:Object = new Object();
		public function setStyleDeclarations(externalManager:IStyleManager2):void
		{
			if (externalManager == null) {
				return;
			}
			backupManager = externalManager;
			var selectorsArray:Array = (styleSelectorArray != null) ? styleSelectorArray : styleManager.selectors;
			for each (var selector:String in selectorsArray) {
				var declaration:CSSStyleDeclaration = externalManager.getStyleDeclaration(selector);
				if (declaration != null) {
					backupStyles[selector] = declaration;
				}
				// We pass in false for the update param, since our loader will updated as needed
				externalManager.setStyleDeclaration(selector, styleManager.getMergedStyleDeclaration(selector), false);
			}
			CollectionManager.instance.enabled = true;
		}
		
		public function unload():void
		{
			if ((backupManager != null) && (backupStyles != null)) {
				for (var selector:String in backupStyles) {
					// We pass in false for the update param, since our unloader will updated as needed
					backupManager.setStyleDeclaration(selector, backupStyles[selector] as CSSStyleDeclaration, false);
				}
			}
			backupStyles = new Object();
			backupManager = null;
		}
	}
}