/*************************************************************************
*
* ADOBE SYSTEMS INCORPORATED
*  Copyright 2010 Adobe Systems Incorporated
*  All Rights Reserved.
*
* NOTICE:  Adobe permits you to use, modify, and distribute this 
* file in accordance with the terms of the Adobe license agreement 
* accompanying it.  If you have received this file from a source 
* other than Adobe, then your use, modification, or distribution 
* of it requires the prior written permission of Adobe.
**************************************************************************/

package com.adobe.portfolio.utils 
{
	/**
	 *  The FileUtil class is a set of utility functions for file names and URLs.
	 * 
	 *  @langversion 3.0
	 *  @playerversion Flash 10.1
	 *  @playerversion AIR 2.0
	 *  @productversion Portfolio 10.0
	 */
	public class FileUtil
	{
		/**
		 *  Get the extension of a url, pathname, or filename
		 * 
		 *  @param A string that's either a url, pathname or filename
		 *  @return The extension (if any)
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 */
		public static function getExtension(url:String):String {
			if (!url || url.length==0)
				return "";
			
			var dotIndex:int = url.lastIndexOf(".");
			if (dotIndex == -1 || dotIndex == (url.length-1))
				return "";
				
			return url.substr(dotIndex+1).toLowerCase();
		}
	}
}