/*************************************************************************
*
* ADOBE SYSTEMS INCORPORATED
*  Copyright 2010 Adobe Systems Incorporated
*  All Rights Reserved.
*
* NOTICE:  Adobe permits you to use, modify, and distribute this 
* file in accordance with the terms of the Adobe license agreement 
* accompanying it.  If you have received this file from a source 
* other than Adobe, then your use, modification, or distribution 
* of it requires the prior written permission of Adobe.
**************************************************************************/

package com.adobe.portfolio.utils
{
	/**
	 * The Rect class exists only for its bindable properites.
	 * 
	 *  @langversion 3.0
	 *  @playerversion Flash 10.1
	 *  @playerversion AIR 2.0
	 *  @productversion Portfolio 10.0
	 */
	[Bindable]
	public class Rect
	{
		public var x:Number;

		public var y:Number;

		public var width:Number;
		
		public var height:Number;
		
		/**
		 *  Constructor.
		 * 
		 *  @param x The x value
		 *  @param y The y value
		 *  @param width The width
		 *  @param height The height
		 * 
		 *  @langversion 3.0
		 *  @playerversion Flash 10.1
		 *  @playerversion AIR 2.0
		 *  @productversion Portfolio 10.0
		 */
		public function Rect(x:Number=0, y:Number=0, width:Number=0, height:Number=0)
		{
			this.x = x;
			this.y = y;
			this.width = width;
			this.height = height;
		}
		
	}
}